##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import netsvc

import sql_db

arch = '''<?xml version="1.0"?>
<form title="Split line">
	<field name="total"/>
	<field name="quantity"/>
	<field name="serial"/>
	<field name="tracking"/>
</form>'''

fields = {
	'total': {'string':'Total quantity', 'type':'float', 'readonly':True},
	'quantity': {'string':'Quantity to split', 'type':'float', 'required':True},
	'serial': {'string':'Serial', 'type':'char', 'required':False},
	'tracking': {'string':'Tracking', 'type':'char', 'required':False},
}

def _get_value(self, uid, datas):
	service = netsvc.LocalService("object_proxy")
	quantity = service.execute(uid, 'stock.lot.line', 'read', [datas['id']], ['product_qty'])[0]['product_qty']
	serial = service.execute(uid, 'ir.sequence', 'get', 'stock.lot.serial')
	tracking = service.execute(uid, 'ir.sequence', 'get', 'stock.lot.tracking')
	return {'total':quantity, 'serial':serial, 'tracking':tracking}

def _split_line(self, uid, datas):
	service = netsvc.LocalService("object_proxy")
	quantity = service.execute(uid, 'stock.lot.line', '_split', datas['id'], datas['form']['quantity'], datas['form']['serial'], datas['form']['tracking'])
	return {}

class wizard_split_lot_line(wizard.interface):
	states = {
		'init': {
			'actions': [_get_value],
			'result': {'type':'form', 'arch':arch, 'fields':fields, 'state':[('split','Split'),('end','Exit')]}
		},
		'split': {
			'actions': [_split_line],
			'result': {'type':'state', 'state':'init'}
		}
	}

wizard_split_lot_line('stock.lot.line.split')

